﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Ports;
using System.Threading;


namespace WindowsFormsApplication1
{
    //2009 By LS
    //Keine Garantie, Autor nicht vergessen, usw.
    //Bitte vor dem Benutzen DENKEN!!!
    public partial class Form1 : Form
    {
        ctlab MyLab = new ctlab();

        byte status = 0;
        byte PIO_1;

        double DAC27_Val;

        string Path = "D:\\";
        string AktFile = "log1.log";
        StreamWriter LogWriter;
        bool logging = false;
        bool init;

        double Spannung16_7 = 0;
        double Spannung24 = 0;
        double Temp0 = 0;

        string ToLog = "";

        

        public Form1()
        {
            InitializeComponent();
        }

        delegate void WriteMessageDelegate(string message, Color farbe);

        void WriteMessage(string message, Color farbe)
        {
            if ( (LogToWindow_checkBox1.Checked) && (Log_richTextBox.InvokeRequired == false) ) // Make sure we're on the right thread
            {      
                    Log_richTextBox.SelectionColor = farbe;
                    Log_richTextBox.AppendText(message + "\n");
                    Log_richTextBox.ScrollToCaret();
            }
            else // Show progress asynchronously
            {
                WriteMessageDelegate Write_Message = new WriteMessageDelegate(WriteMessage);
                BeginInvoke( Write_Message, new object[] { message, farbe });
            }


        }

        private void LogMessage(string message, bool ToFile)
        {
            if ( (logging) && (ToFile) )
            {
                try
                {
                    LogWriter.WriteLine(message);
                }
                catch (Exception exc)
                {
                    MessageBox.Show(exc.ToString(), "FILE IO ERROR", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            searchComPorts();
            numericUpDown1.Value = timer1.Interval;
            numericUpDown2.Value = Logging_timer.Interval;
            numericUpDown3.Value = (decimal) (toggle_timer.Interval / 1000);
            DAC27_Val = DAC27_trackBar1.Value / 1000.0;
            DAC27_label.Text = DAC27_Val.ToString("F2") + "V";
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if(serialPort1.IsOpen)
            {
                serialPort1.Close();
            }
            if (logging)
            {
                LogWriter.Close();
            }
        }

        private void connect_btn_Click(object sender, EventArgs e)
        {
            if ((!serialPort1.IsOpen))
            {
                serialPort1.PortName = availablecomponents_combobox.Text;
                try
                {
                    serialPort1.Open();
                    
                }
                catch (SystemException se)
                {
                    WriteMessage(DateTime.Now.ToLongTimeString() + ": COM Error: " + se.ToString(), Color.Red);
                    LogMessage(DateTime.Now.ToLongTimeString() + ": COM Error: " + se.ToString(), LogOnlyValuescheckBox1.Checked);
                    return;
                }
                if (serialPort1.IsOpen)
                {
                    serialPort1.DiscardInBuffer();
                    serialPort1.DiscardOutBuffer();
                    serialPort1.ReceivedBytesThreshold = 1; 
                    connect_btn.Text = "disconnect";

                    status = 200;    //init  
                    init = true;

                    WriteMessage(DateTime.Now.ToLongTimeString() + ": connected", Color.Green);
                    timer1.Enabled = true;
                    timer1.Start();
                }
                else
                {
                    WriteMessage(DateTime.Now.ToLongTimeString() + ": COM Error", Color.Red);
                    LogMessage(DateTime.Now.ToLongTimeString() + ": COM Error", LogOnlyValuescheckBox1.Checked);
                }

            }
            else
            {
                timer1.Enabled = false;
                Logging_timer.Enabled = false;
                connect_btn.Text = "connect";
                status = 0;
                serialPort1.Close();
                timer1.Stop();
                Logging_timer.Stop();
                WriteMessage(DateTime.Now.ToLongTimeString() + ": disconnected", Color.Maroon);
            }
            Log_richTextBox.ScrollToCaret();
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            string ToSend = "ERROR";

            //WriteMessage(DateTime.Now.ToLongTimeString() + ": Anfrage:", Color.Blue);

            if (serialPort1.IsOpen)
            {
                try
                {
                    switch (status) {
                       // case 1: ToSend = MyLab.CMD_getVal(ctlab.Addr_ADA, ctlab.ADC16_7); status = 2; break; //ADC16 INPUT 0
                        case 1: ToSend = MyLab.CMD_getVal(ctlab.Addr_ADA, ctlab.LM75); status = 2; break; //I2C Temp
                        case 2: ToSend = MyLab.CMD_getVal(ctlab.Addr_DIV, ctlab.ADC24_iL); timer1.Stop(); break; //ADC24 Integriert


                        
                        //Init
                        case 200: ToSend = ctlab.IDN; status = 201; break;//idn
                        case 201: ToSend = ToSend = MyLab.CMD_setVal(ctlab.Addr_ADA, ctlab.DAC16_7, DAC27_Val); status = 202; break;//init DAC
                        case 202: PIO_1 = 0; //clear Output
                            IO1_0.Checked = false;
                            IO1_1.Checked = false;
                            ToSend = MyLab.CMD_setVal(ctlab.Addr_ADA, ctlab.PIO1, 0);
                            status = 203; break;//init PIO
                        case 203: ToSend = MyLab.CMD_setVal(ctlab.Addr_DIV, ctlab.ADC24_Range, ctlab.Range_DC2_5V); //ADC24 +-2.5V
                            timer1.Stop();
                            Logging_timer.Enabled = true; //start Logging Timer
                            Logging_timer.Interval = timer1.Interval;
                            Logging_timer.Start();
                        break;

                        default: WriteMessage(DateTime.Now.ToLongTimeString() + "\tUnknown Status", Color.Red); status = 1; break;
                    }

                    serialPort1.Write(ToSend);

                    //WriteMessage(DateTime.Now.ToLongTimeString() + "\t" + ToSend +  "\t", Color.Green);
      
                }

                catch (TimeoutException)
                {
                    WriteMessage(DateTime.Now.ToLongTimeString() + ": Keine Antwort", Color.Red);
                    LogMessage(DateTime.Now.ToLongTimeString() + ": Keine Antwort", LogOnlyValuescheckBox1.Checked);
                }
            }
        }

        private void Logging_timer_Tick(object sender, EventArgs e)
        {
            if (init)
            {
                init = false; //don't log for the first time
                serialPort1.DiscardInBuffer();
                serialPort1.DiscardOutBuffer();
                //serialPort1.ReceivedBytesThreshold = 16; //throw event if 16Bits are recieved
                WriteMessage(DateTime.Now.ToLongTimeString() + "\tStart", Color.DarkGreen);
                Logging_timer.Interval = (int)numericUpDown2.Value;
            }
            else
            {
                WriteMessage(DateTime.Now.ToLongTimeString() + "\t" + Spannung24.ToString("F7") + "V\t" + Temp0.ToString("F1") + "°C\t" + ToLog, Color.Black);
                LogMessage(DateTime.Now.ToLongTimeString() + "\t" + Spannung24.ToString("F7") + "\t" + Temp0.ToString("F1") + "\t" + ToLog, true);
                
                if (ToLog.Length > 0)
                {
                    ToLog = "";
                }
            }
            status = 1;
            timer1.Start(); //next cycle      
        }


        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            byte Addr, ch;
            double val;

            string s = serialPort1.ReadLine();
            
            if (!init)
            {
                try
                {
                    if (debugcheckBox1.Checked)
                    {
                        WriteMessage("Recieved: ", Color.Green);
                        WriteMessage(s, Color.Blue);
                    }

                    if (s[0] != '*')
                    {
                        Addr = byte.Parse(s.Substring(1, 1));
                        // WriteMessage("Addr = " + Addr.ToString(), Color.Blue);

                        s = s.Substring(3, s.Length - 3);

                        ch = byte.Parse(s.Substring(0, s.IndexOf('=')));
                        // WriteMessage("ch = " + ch.ToString(), Color.Blue);

                        if (ch <= 254) //not IDN and not ACK
                        {
                            s = s.Substring(s.IndexOf('=') + 1, s.Length - s.IndexOf('=') - 1);

                            val = double.Parse(s.Replace('.', ','));
                            // WriteMessage("val = " + val.ToString(), Color.Blue);

                            if (Addr == ctlab.Addr_ADA)
                            {
                                if (ch == ctlab.ADC16_7)
                                {
                                    Spannung16_7 = val;
                                }
                                else
                                {
                                    if (ch == ctlab.LM75)
                                    {
                                        if ((CorrectTempcheckBox1.Checked) && (val > 128))
                                        {
                                            Temp0 = val;
                                        }
                                        else
                                        {
                                            Temp0 = - (255 - val);
                                        }
                                    }
                                }

                            }
                            else if (Addr == ctlab.Addr_DIV)
                            {
                                if (ch == ctlab.ADC24_iL)
                                {
                                    Spannung24 = val;
                                }
                            }

                        }
                    }

                }
                catch (Exception)
                {
                    WriteMessage(DateTime.Now.ToLongTimeString() + "\t Recieve parse ERROR ", Color.Red);
                   // 
                }

            }
            else
            {
                WriteMessage(s, Color.Black);
            }

        }


        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            timer1.Interval = (int)numericUpDown1.Value;
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            Logging_timer.Interval = (int)numericUpDown1.Value;
        }

        private void Update_button_Click(object sender, EventArgs e)
        {
            searchComPorts();
        }

        private void searchComPorts()
        {
            availablecomponents_combobox.Items.Clear();
            foreach (string s in SerialPort.GetPortNames())         
                availablecomponents_combobox.Items.Add(s);

            if (availablecomponents_combobox.Items.Count > 0)
            {
                availablecomponents_combobox.SelectedIndex = availablecomponents_combobox.Items.Count - 1;
             //   WriteMessage(DateTime.Now.ToLongTimeString() + ": COM Ports aktualisiert", Color.DarkOrange);
            }
            else
            {
                WriteMessage(DateTime.Now.ToLongTimeString() + ": Keinen COM Port gefunden!", Color.Red);
            }
        }

        private void SelectFolderbtn1_Click(object sender, EventArgs e)
        {
            folderBrowserDialog1.RootFolder = System.Environment.SpecialFolder.MyComputer;
            DialogResult result = folderBrowserDialog1.ShowDialog();
            if (result == DialogResult.OK)
            {
                LogBtn.Enabled = true;

                Path = folderBrowserDialog1.SelectedPath + '\\';
                PathtextBox1.Text = Path;
            }
        }

        private void LogBtn_Click(object sender, EventArgs e)
        {
            if (!logging)
            {
                AktFile = DateTime.Now.ToShortDateString().Replace('.', '_') + "_" + DateTime.Now.ToLongTimeString().Replace(':', '_') + ".log";
                FiletextBox1.Text = AktFile;
                LogWriter = File.CreateText(Path + AktFile);

                logging = true;
                LogMessage("Time\tSpannung24\tTemp", true);
                LogBtn.Text = "Stop Logging";
            }
            else
            {
                LogWriter.Close();
                logging = false;
                LogBtn.Text = "Start Logging";
            }

        }

        private void ClearLogBtn_Click(object sender, EventArgs e)
        {
            Log_richTextBox.Clear();
        }

        private void CommentBtn_Click(object sender, EventArgs e)
        {
            //WriteMessage(DateTime.Now.ToLongTimeString() + ": " + CommentBox1.Text, Color.Yellow);
            ToLog = CommentBox1.Text;
        }

        private void IO1_0_CheckedChanged(object sender, EventArgs e)
        {

            if (IO1_0.Checked)
            {
                PIO_1 |= ((1 << 0) & 0xff);
            }
            else
            {
                PIO_1 &= (~(1 << 0) & 0xff);
            }

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(MyLab.CMD_setVal(ctlab.Addr_ADA, ctlab.PIO1, PIO_1));
            }
        }

        private void IO1_1_CheckedChanged(object sender, EventArgs e)
        {
            if (IO1_1.Checked)
            {
                PIO_1 |= ((1 << 1) & 0xff);
            }
            else
            {
                PIO_1 &= (~(1 << 1) & 0xff);
            }

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(MyLab.CMD_setVal(ctlab.Addr_ADA, ctlab.PIO1, PIO_1));
            }
        }

        private void Clear_PIO_1_button1_Click(object sender, EventArgs e)
        {
            IO1_0.Checked = false;
            IO1_1.Checked = false;
            PIO_1 = 0;

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(MyLab.CMD_setVal(ctlab.Addr_ADA, ctlab.PIO1, PIO_1));
            }
        }

        private void DAC27_trackBar1_Scroll(object sender, EventArgs e)
        {
            DAC27_Val = DAC27_trackBar1.Value / 1000.0;
            DAC27_label.Text = DAC27_Val.ToString("F2") + "V";

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(MyLab.CMD_setVal(ctlab.Addr_ADA, ctlab.DAC16_7, DAC27_Val)); //DAC27 Value
            }
        }

        private void toggle_timer_Tick(object sender, EventArgs e)
        {
            IO1_0.Checked = !IO1_0.Checked;
        }

        private void Toggle_checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            toggle_timer.Enabled = Toggle_checkBox1.Checked;
        }

        private void numericUpDown3_ValueChanged(object sender, EventArgs e)
        {
            toggle_timer.Interval = (int) (numericUpDown3.Value * 1000);
        }
     
    }
}
